      program convert_2
c
      character*100 ia1,ia2
c
      parameter(nlast=100)
c
      ia2(41:53)='refmanx/chxx/'
      open(1,file='dpdicf.tex')
      open(2,file='commands.html')
c
c  write out beginning header info for html file
c
      write(2,1)
 1    format(
     1'<!----- <commands.html> Dictionary of Dataplot Commands ----->',/,
     1' ',/,
     1'<html>',/,
     1' ',/,
     1'<head>',/,
     1'   <title> Dictionary of Dataplot Commands (4/93)</title>',/,
     1'</head>',/,
     1'',/,
     1'<body background = "../gif/background1.gif"',/,
     1'      text="#000000" link="#0000ff" vlink="#0000d7" ',
     1' alink="#ee0000">',/,
     1'<basefont size = 3>',/,
     1' ',/)
      write(2,2)
 2    format(
     1'<table>',/,
     1'<tr>',/,
     1'   <td width = 400 align = left>',/,
     1'      <font size = "5">',/,
     1'         <a href = "homepage.html">',/,
     1'            Dataplot',/,
     1'         </a>',/,
     1'      </font>',/,
     1'   </td>',/,
     1'</tr>',/,
     1'</table>',/,
     1'',/,
     1'<hr size = 4>',/,
     1'',/)
      write(2,3)
 3    format(
     1'<p>',/,
     1'This is a dictionary of Dataplot commands and keywords',/,
     1'as of 4/93.',/,
     1'<p>',/,
     1'',/)
c
c  skip some header lines
c
      do5i=1,2
        read(1,'(a)')ia1
 5    continue
c
c  Do initial headers
c
      write(2,12)
 12   format('<ol>')
      write(2,17)
 17   format(
     1'<li> <a href="#A">A</a>'/,
     1'<li> <a href="#B">B</a>'/,
     1'<li> <a href="#C">C</a>'/,
     1'<li> <a href="#D">D</a>'/,
     1'<li> <a href="#E">E</a>'/,
     1'<li> <a href="#F">F</a>'/,
     1'<li> <a href="#G">G</a>'/,
     1'<li> <a href="#H">H</a>'/,
     1'<li> <a href="#I">I</a>'/,
     1'<li> <a href="#J">J</a>'/,
     1'<li> <a href="#K">K</a>'/,
     1'<li> <a href="#L">L</a>'/,
     1'<li> <a href="#M">M</a>'/,
     1'<li> <a href="#N">N</a>'/,
     1'<li> <a href="#O">O</a>'/,
     1'<li> <a href="#P">P</a>'/,
     1'<li> <a href="#Q">Q</a>'/,
     1'<li> <a href="#R">R</a>'/,
     1'<li> <a href="#S">S</a>'/,
     1'<li> <a href="#T">T</a>'/)
      write(2,18)
 18   format(
     1'<li> <a href="#U">U</a>'/,
     1'<li> <a href="#V">V</a>'/,
     1'<li> <a href="#W">W</a>'/,
     1'<li> <a href="#X">X</a>'/,
     1'<li> <a href="#Y">Y</a>'/,
     1'<li> <a href="#Z">Z</a>'/,
     1'<li> <a href="#Miscellaneous">Miscellaneous</a>'/)
      write(2,22)
 22   format('</ol>')
c
c  main loop:
c    "----" indicates a new section
c    blank lines are skipped
c    others are split into 2 parts (data file name, description)
c
      do100i=1,20000
        print *,'i=',i
        ia1=' '
        read(1,'(a100)',end=9999)ia1
        if(ia1(1:3).eq.'---')then
          call parse1(ia1)
        elseif(ia1.eq.' ')then
          goto100
        else
          call parse2(ia1)
        endif
 100  continue
c
 9999 continue
      write(2,900)
 900  format(/,'</table>'//,'</body>',/,'</html>',/)
c
      stop
      end
      subroutine parse1(ia)
c
c  new section
c
      parameter(nlast=100)
      character*(*) ia
c
      save icall
      data icall /0/
c
      icall=icall+1
c
      do10i=1,nlast
        nstart=i
        if(ia(i:i).ne.'-'.and.ia(i:i).ne.' ')goto19
 10   continue
 19   continue
      if(ia(nstart:nstart+12).eq.'MISCELLANEOUS')then
        nstop=nstart+12
        ia(nstart:nstop)='Miscellaneous'
      else
        nstop=nstart
      endif
c
      if(icall.gt.1)then
        write(2,99)
      else
        write(2,98)
      endif
 99   format(/,'</table>'/,'<p>'/,'<hr size = 4>'/,'<p>')
 98   format(/,'<p>'/,'<hr size = 4>'/,'<p>')
c
      write(2,101)ia(nstart:nstop)
 101  format('<h1> <a name="',a,'">')
      write(2,103)ia(nstart:nstop)
 103  format('         ',a,'</a>'/,'</h1>')
c
c  start a new table
c
      write(2,201)ia(nstart:nstop)
 201  format(
     1'<p>'/,
     1'<table border>'/,
     1' '/
     1'<caption>'/
     1'    <font size=4>'/,
     1'     ',a,/,
     1'    </font>'/,
     1'</caption>')
c
      return
      end
      subroutine parse2(ia)
c
c  new section
c
      parameter(nlast=100)
      character*(*) ia
c
c  start a new row
c
      nstrt1=1
      do10i=28,1,-1
        nstop1=i
        if(ia(i:i).ne.' ')goto19
 10   continue
 19   continue
c
      nstrt2=29
      nstop2=80
      do30i=100,nstrt2,-1
        nstop2=i
        if(ia(i:i).ne.' ')goto39
 30   continue
 39   continue
c
      write(2,101)ia(nstrt1:nstop1)
 101  format(
     1' '/,
     1'<tr>'/,
     1'   <td>'/,
ccccc1'   <a href = '/,
ccccc1'     "ftp://ftp.nist.gov/pub/dataplot/other/reference/',a,'">'/,
ccccc1'   ',a,'</a>'/,
     1'   ',a,/,
     1'   </td>')
      write(2,103)ia(nstrt2:nstop2)
 103  format(
     1'   <td>'/,
     1'   ',a,/,
     1'   </td>'/,
     1'</tr>')
c
      return
      end
