      program filter
C
c  Filter program to read FrameMaker HTML file after it has been
c  run through filter.f program.
c
c  This automates some of the conversion from the FrameMaker HTML
c  to the format that I want.
c
      character*100 ia1
      character*100 ia2
      character*4 irflag
      character*50 icomm,idesc
      character*50 ifile
c
c  add in header template
c
      irflag='off'
      nout=10
      ntemp1=11
      open(nout,file='junk.dat')
      open(ntemp1,file='header.html.template')
      do 1 i=1,100
        read(ntemp1,'(a)',end=9,err=9) ia1
        nlast=last(ia1,100)
        write(nout,'(a)') ia1(1:nlast)
 1    continue
 9    continue
      close(ntemp1)
C
c  process the file
c
 10   continue
        ia1=' '
        ia2=' '
        ifile=' '
        icomm=' '
        idesc=' '
        read(*,'(a)',end=9999,err=9999)ia1
c
        nlast=last(ia1,100)
c
        if(irflag.eq.'on')then
          if(ia1(1:4).eq.'<dl>')goto10
          if(ia1(1:5).eq.'</dl>')then
            irflag='off'
            write(nout,'(a80)') ' '
            write(nout,'(a80)') '</font>'
            write(nout,'(a80)') '</table>'
            goto10
          endif
c
          iequal=nequal(ia1,100)
          nchars1=(iequal-1)-5
          icomm(1:nchars1)=ia1(6:iequal-1)
          ifile=icomm
          do320j=1,nchars1
            itemp=ichar(ifile(j:j))
            if(itemp.ge.65 .and. itemp.le.91) itemp=itemp+32
            ifile(j:j)=char(itemp)
            if(ifile(j:j).eq.'	')ifile(j:j)=' '
 320      continue
          nchars3=last(ifile,50)
          do330j=nchars3,1,-1
            if(ifile(j:j).eq.' ')ifile(j:j)='_'
            ifile(j+1:j+1)=ifile(j:j)
 330      continue
          nchars3=nchars3+1
          ifile(1:1)='"'
          ifile(nchars3+1:nchars3+5)='.html'
          ifile(nchars3+6:nchars3+7)='">'
          nchars3=nchars3+7
          nchars2=nlast-(iequal+1)+1
          idesc(1:nchars2)=ia1(iequal+1:nlast)
          write(nout,'(a)') '<tr>'
          write(nout,'(a)') ' '
          write(nout,'(a)') '<td>'
          write(nout,'(a)') '<a href = ',ifile(1:nchars3)
          write(nout,'(a)') icomm(1:nchars1)
          write(nout,'(a)') '</a>'
          write(nout,'(a)') '</td>'
          write(nout,'(a)') ' '
          write(nout,'(a)') '<td>'
          write(nout,'(a)') idesc(1:nchars2)
          write(nout,'(a)') '</td>'
          write(nout,'(a)') ' '
          write(nout,'(a)') '</tr>'
          write(nout,'(a)') ' '
          goto10
        endif
c
 20     continue
        if(ia1(1:4).eq.'<h1>')then
          write(nout,'(a)') ia1
ccccc     write(nout,'(a)') '<p>'
        elseif(ia1(1:4).eq.'<h2>')then
          if(ia1(6:12).ne.'PURPOSE')write(nout,'(a)') '</ul>'
          write(nout,'(a)') ia1(1:nlast)
          write(nout,'(a)') '<ul>'
          if(ia1(6:12).eq.'RELATED')then
            write(nout,'(a)') '<table>'
            write(nout,'(a)') '<font size = "2">'
            irflag='on'
          endif
        elseif(ia1(1:4).eq.'<dl>')then
ccccc     write(nout,'(a)') '<ul>'
          write(nout,'(a)') ' '
        elseif(ia1(1:5).eq.'</dl>')then
ccccc     write(nout,'(a)') '</ul>'
          write(nout,'(a)') ' '
        elseif(ia1(1:6).eq.'<dt>  ')then
          write(nout,'(a)') '<p>'
        elseif(ia1(1:5).eq.'<dt> ')then
          write(nout,'(a)') ia1(6:nlast),' <br>'
        else
c
          if(ia1(nlast-2:nlast).eq.'<p>')then
            write(nout,'(a)') ia1(1:nlast-3)
            write(nout,'(a)') '<p>'
          else
            write(nout,'(a)') ia1(1:nlast)
          endif
        endif
c
      goto 10
c
 9999 continue
c
c  add in tail template
c
      ntemp1=11
      open(ntemp1,file='tail.html.template')
      do 1001 i=1,100
        read(ntemp1,'(a)',end=1009,err=1009) ia1
        nlast=last(ia1,100)
        write(nout,'(a)') ia1(1:nlast)
 1001 continue
 1009 continue
      close(ntemp1)
c
      stop
      end
      integer function last(ia,maxchr)
c
c  function to determine the last non-blank character in a string.
c
      character*(*) ia
c
      last=0
c
      do10i=maxchr,1,-1
        if(ia(i:i).ne.' ')then
          last=i
          return
        endif
 10   continue
c
      return
      end
      integer function nequal(ia,maxchr)
c
c  function to determine the first "=" character in a string.
c
      character*(*) ia
c
      nequal=0
c
      do10i=1,maxchr,1
        if(ia(i:i).eq.'=')then
          nequal=i
          return
        endif
 10   continue
c
      return
      end
