#!/usr/local/bin/tclsh7.5

source /home/lipman/public_html/cgi-bin/cgi.tcl
source /home/lipman/public_html/cgi-bin/wdpsite.tcl

cgi_eval {

#  get input
   cgi_input
   foreach var {userfile macro_name} {if [catch {cgi_import $var}] {set $var ""}}
   
#  userfile is not null and macro exists
   if {$userfile != "" && [info exists macro($macro_name)]} {

#  set content type to be Dataplot macro
      cgi_http_head {cgi_content_type application/x-dataplot}
#      cgi_http_head {cgi_content_type text/plain}

      set lmacro [split $macro($macro_name) \n]
      for {set i 0} {$i < [llength $lmacro]} {incr i} {
         set line [string trim [lindex $lmacro $i]]

#  if read, substitute userfile name
         if {[string range $line 0 3] == "READ" || \
             [string range $line 0 3] == "read"} {
            set args [string range $line 5 end]
            set args [string range $args [string first " " $args] end]
            puts "READ $userfile [string trim $args]"
         } else {
            puts $line
         }
      }

#  error with input, output plain text message
   } else {
      cgi_http_head {cgi_content_type text/plain}
      
#  no userfile specified
      if {$userfile == ""} {
         puts "No user file name specified"
      
#  unknown macro specified
      } elseif {![info exists macro($macro_name)]} {
         puts "Dataplot macro $macro_name not found in wdpsite.tcl"
      }
   }
}
